pipeline {
    // Added option to run build on specific agent
	agent {
		label ('kul')
	}
    
    // Adding Environemtn Section define Build Specific Environment Variables
    environment {
        JAVA_HOME = "/usr/lib/jvm/java-8-openjdk-amd64"
	    BRANCH_NAME = "${GIT_BRANCH}"
    }

	tools {
        // Install the Maven version configured as "M3" and add it to the path.
        maven "mvn_3.6.3"
    }

    stages {
		stage('Run Configuration Checks using Ansible'){
			steps{
				git 'https://gitlab.com/munish.bijnor/my-java-application.git'
				//ansiblePlaybook become: true, installation: 'ansible', inventory: 'hosts', playbook: 'configure-kubernetes-cluster.yaml'
			}
		}
        // Adding Sonar Analysis Stage for Static Scanning of Code for Potential Coe Quality issues
	stage('Sonar Analysis'){
	  steps {
	    	git 'https://gitlab.com/munish.bijnor/my-java-application.git'
            sh "mvn -Dmaven.test.failure.ignore=true clean package sonar:sonar -Dsonar.branch.name=${BRANCH_NAME}"
	  }
	}
        stage('Build') {
            	steps {
               		// Get some code from a GitHub repository
                	//git 'https://github.com/kul-unisys/sample-java-app.git'
                	git 'https://gitlab.com/munish.bijnor/my-java-application.git'
	
	                // Run Maven on a Unix agent.
	                sh "mvn -Dmaven.test.failure.ignore=true clean package"
	        }
		post {
			success{
				// Archive PAckaged file
				archiveArtifacts artifacts: 'target/*.war', followSymlinks: false
			}
		}
        }
		
		stage('OWASP DC Scan'){
			steps{
				sh "echo DC-SCAN"
				//sh "mvn clean install"
				//publishHTML([allowMissing: true, alwaysLinkToLastBuild: true, keepAll: true, reportDir: '', reportFiles: 'target/dependency-check-report.html', reportName: 'Dependency Checks Report', reportTitles: ''])
				}
		}
	    stage('Distribute Package'){
		    when { branch "release" }
		    steps{
			    //sh "mvn deploy --settings mvn-settings.xml"
				sh "echo Deploy"
		    }
	    }
	    stage('Scan Base Image'){
		    steps{
			    //sh label: '', script: 'trivy image --format template --template "@junit.tpl" -o image-scan-report.xml kulbhushanmayer/ls-demo:2.0'
			    //junit allowEmptyResults: true, testResults: 'image-scan-report.xml'
				sh "echo Scan-Base-Image"
		    }
	    }
    }
}